Imports System.Security.Cryptography
Imports System.Text

Module Module1

    Sub Main()
        Dim secret As String = "das ist ein geheimer text"

        Dim encryptedSecret As Byte() = Encrypt(secret)
        Dim decryptedSecret As String = Decrypt(encryptedSecret)

        Console.WriteLine(decryptedSecret)
    End Sub


    Private Function Encrypt(ByVal data As String) As Byte()
        ' umwandeln von string zu byte array
        Dim dataBytes As Byte() = Encoding.UTF8.GetBytes(data)

        ' verschlsseln mit user key
        Return ProtectedData.Protect(dataBytes, Nothing, DataProtectionScope.CurrentUser)
    End Function 'Encrypt


    Private Function Decrypt(ByVal data() As Byte) As String
        ' entschlsseln mit user key
        Dim decryptedData As Byte() = ProtectedData.Unprotect(data, Nothing, DataProtectionScope.CurrentUser)

        ' umwandeln von byte array zu string
        Return Encoding.UTF8.GetString(decryptedData)
    End Function 'Decrypt
End Module
